VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} kmlProgram2 
   Caption         =   "Google Earth Path to Shapefile"
   ClientHeight    =   1800
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4875
   OleObjectBlob   =   "kmlProgram2.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "kmlProgram2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub UserForm_Initialize()
    tbInputPath.Value = "F:\CSIF\data\34\New Folder"
    tbInputFile.Value = "Google Earth - New Path.kml"
End Sub

Private Function CreateSPref(prjPath As String)
    Open prjPath For Output As #1
    Dim tempString As String
    tempString = "GEOGCS[""GCS_WGS_1984"",DATUM[""D_WGS_1984"",SPHEROID[""WGS_1984"",6378137.0,298.257223563]],PRIMEM[""Greenwich"",0.0],UNIT[""Degree"",0.0174532925199433]]"
    Print #1, tempString
    Close 1
End Function

Private Function AddShapefile(pPath As String, pName As String)

    Dim pWorkspaceFactory As IWorkspaceFactory
    Dim pFeatureWorkspace As IFeatureWorkspace
    Dim pFeatureLayer As IFeatureLayer
    Dim pMxDocument As IMxDocument
    Dim pMap As IMap
    
    
    'Create a new ShapefileWorkspaceFactory object and open a shapefile folder
    Set pWorkspaceFactory = New ShapefileWorkspaceFactory
    Set pFeatureWorkspace = pWorkspaceFactory.OpenFromFile(pPath, 0)
    'Create a new FeatureLayer and assign a shapefile to it
    Set pFeatureLayer = New FeatureLayer
    
    Dim inputFileName3 As String, stringLength3 As Long
    stringLength3 = Len(pName) - 4
    inputFileName3 = Left(pName, stringLength3) & ".shp"
    
    Set pFeatureLayer.FeatureClass = pFeatureWorkspace.OpenFeatureClass(inputFileName3)
    pFeatureLayer.name = pFeatureLayer.FeatureClass.AliasName
    'Add the FeatureLayer to the focus map
    Set pMxDocument = Application.Document
    Set pMap = pMxDocument.FocusMap
    pMap.AddLayer pFeatureLayer
    Application.RefreshWindow


End Function

Private Sub cmdOK_Click()
' Created by Daniel Cossette
' dk7@yahoo.com
 
    ' Convert the kml file to a text file
    Dim ConvertedKMLtoTXTfile As String
    ConvertedKMLtoTXTfile = ConvertKMLpath2TXT(tbInputPath.Value & "\" & tbInputFile.Value, tbInputPath.Value & "\")

    ' Convert the txt file to dbase file
    ConvertTXT2DBF tbInputPath.Value & "\" & ConvertedKMLtoTXTfile & ".txt", tbInputPath.Value & "\"
    
    ' need to delete the second file from the KMLtoTXT conversion
    KillProperly tbInputPath.Value & "\" & ConvertedKMLtoTXTfile & ".txt"

    ' Convert the dbase file to a polyline
    ConvertDBF2SHP tbInputPath.Value, ConvertedKMLtoTXTfile & ".dbf", tbInputPath.Value, tbInputFile.Value
   
    ' Assign the Spatial Reference
    Dim tempString2 As String, stringLength2 As Long
    stringLength2 = Len(tbInputFile.Value) - 4
    tempString2 = Left(tbInputFile.Value, stringLength2)
    CreateSPref tbInputPath.Value & "\" & Left(tbInputFile.Value, stringLength2) & ".prj"
   
    ' Select by location with a buffer
    
    
    ' Convert the selected to kml
    
    
    ' Open the file in Google Earth
    
    
    Dim StrReply As String
    StrReply = MsgBox("Complete - the path has successfully been converted. Do you wish to add the shapefile to the map.", vbYesNo, "go Habs go!")

    If StrReply = 6 Then AddShapefile tbInputPath.Value, tbInputFile.Value
    
    ' need to delete the second file from the KMLtoTXT conversion
    KillProperly tbInputPath.Value & "\" & ConvertedKMLtoTXTfile & ".dbf"
    KillProperly tbInputPath.Value & "\" & ConvertedKMLtoTXTfile & ".dbf.xml"



    Me.Hide
    Unload Me

End Sub

Public Sub KillProperly(Killfile As String)
    If Len(Dir$(Killfile)) > 0 Then
        SetAttr Killfile, vbNormal
        Kill Killfile
    End If
End Sub

Private Function SelectByLocation(pShapefile As String)

    ' Create the Geoprocessor object
    Dim GP As Object
    Set GP = wscript.CreateObject("esriGeoprocessing.GPDispatch.1")
    
    ' Load required toolboxes...
    GP.AddToolbox "C:/Program Files/ArcGIS/ArcToolbox/Toolboxes/Data Management Tools.tbx"
    
    ' Script arguments...
    Output_Layer_Name = wscript.arguments.item(0)
    
    Selection_type = wscript.arguments.item(1)
    If Selection_type = "#" Then
     Selection_type = "NEW_SELECTION" ' provide a default value if unspecified
    End If
    
    Search_Distance = wscript.arguments.item(2)
    
    Select_Layer = wscript.arguments.item(3)
    
    Overlap_Type = wscript.arguments.item(4)
    If Overlap_Type = "#" Then
     Overlap_Type = "INTERSECT" ' provide a default value if unspecified
    End If
    
    Input_Layer = wscript.arguments.item(5)
    
    ' Local variables...
    
    ' Process: Select Layer By Location...
    GP.SelectLayerByLocation_management Input_Layer, Overlap_Type, Select_Layer, Search_Distance, Selection_type




End Function




Private Function CreateLn(ByRef pPointFrom As IPoint, pPointTo As IPoint) As ILine
    Set CreateLn = New Line
    CreateLn.PutCoords pPointFrom, pPointTo
End Function

Private Function CreatePt(ByVal dX As Double, _
ByVal dY As Double) As IPoint
Set CreatePt = New Point
CreatePt.PutCoords dX, dY
End Function


Private Function ConvertDBF2SHP(inputPath As String, inputFileName As String, outputLocation As String, outputName As String)

  '----- open the table -----
  Dim pWorkspaceFactoryTable As IWorkspaceFactory
  Set pWorkspaceFactoryTable = New ShapefileWorkspaceFactory
  Dim pWorkspaceTable As IWorkspace
  Dim pFWSTable As IFeatureWorkspace
  Set pWorkspaceTable = pWorkspaceFactoryTable.OpenFromFile(inputPath, 0) ' change here
  Dim pTable As ITable
  Set pFWSTable = pWorkspaceTable
  
  Dim inputFileName2 As String, stringLength As Long
  stringLength = Len(inputFileName) - 4
  inputFileName2 = Left(inputFileName, stringLength)
  
  
  Set pTable = pFWSTable.OpenTable(inputFileName2) ' change here
  
  Dim ID_in_index As Integer
  Dim ID_in_type As String
  Dim pFields As IFields
  Dim pField As IField
  Set pFields = pTable.Fields
  ID_in_index = pFields.FindField("height") ' change here
   
  
  Set pField = pFields.Field(ID_in_index) ' change here
  ID_in_type = pField.Type
    
  '***** create shapefile function -- do it here to generate correct ID field type
    Dim inputFileName4 As String, OutputFilename4 As String
  stringLength = Len(outputName) - 4
  OutputFilename4 = Left(outputName, stringLength)
  
  
  CreateShapefile ID_in_type, OutputFilename4
  '***** create shapefile function *****
    
  '----- set up table and table properties to read -----
  Dim pCursor As ICursor
  Dim pQueryfilter As IQueryFilter2
  Set pQueryfilter = New QueryFilter
  If ID_in_type >= 0 And ID_in_type < 4 Then pQueryfilter.WhereClause = "long" & " <> 0 AND " & "lat" & " <> 0 AND " & "height" & " >= 0"
  If ID_in_type = 4 Then pQueryfilter.WhereClause = "height" & " <> ''"
  If ID_in_type > 4 Then
    MsgBox ("ID field type not supported --> Processing terminated.")
    Exit Function
  End If
  
  Set pCursor = pTable.Search(pQueryfilter, True)
  Dim pRow As IRow
  Dim RowCounter As Long
  Dim RowCount As Long
  RowCount = pTable.RowCount(pQueryfilter)
        
  '----- open the shapefile -----
  Dim pWorkspaceFactory As IWorkspaceFactory
  Dim pWorkspace As IWorkspace
  Dim pFWS As IFeatureWorkspace
  Set pWorkspaceFactory = New ShapefileWorkspaceFactory
  Set pFWS = pWorkspaceFactory.OpenFromFile(outputLocation, 0)
  Dim pFeatureClass As IFeatureClass
  Set pFeatureClass = pFWS.OpenFeatureClass(OutputFilename4 & ".shp")
  Dim pDataset As IDataset
  Set pDataset = pFeatureClass
  Dim ID_out_index As Variant
  ID_out_index = pFeatureClass.FindField("height")
    
  '----- create variables to store X Y & IDs -----
  Dim xVal As Double
  Dim yVal As Double
  Dim xVal2 As Double
  Dim yVal2 As Double
  Dim rowID As Variant
  Dim rowID2 As Variant
  
  '----- get field indexes for fields to read from -----
  Dim Xindex As Integer
  Dim Yindex As Integer
  Dim IDindex As Integer
  Xindex = pTable.FindField("long")
  Yindex = pTable.FindField("lat")
  IDindex = pTable.FindField("height")
  
  '----- create variables to generate a new feature and populate fields-----
  Dim pGeomColl As IGeometryCollection
  Dim pSegColl As ISegmentCollection
  Dim pLine As ILine, pPolyline As IPolyline
  Dim pFeature As IFeature
  Set pSegColl = New path
  
  '***** DO IT *****
  '----- if merging by segment IDs -----
  Dim strMergebyID As Boolean
  strMergebyID = True
    
  If strMergebyID = True Then
    '--- get first row ---
    Set pRow = pCursor.NextRow
    xVal = pRow.Value(Xindex)
    yVal = pRow.Value(Yindex)
    rowID = pRow.Value(IDindex)
    '--- get second row ---
    Set pRow = pCursor.NextRow
    xVal2 = pRow.Value(Xindex)
    yVal2 = pRow.Value(Yindex)
    rowID2 = pRow.Value(IDindex)
    '--- if second is same ID as first then start the feature ---
    If rowID2 = rowID Then
      Set pLine = CreateLn(CreatePt(xVal, yVal), CreatePt(xVal2, yVal2))
      Set pSegColl = New path
      pSegColl.AddSegment pLine
    End If
    '--- assign second row to fnode position ---
    xVal = xVal2
    yVal = yVal2
    zVal = zVal2
    rowID = rowID2
      
    Set pRow = pCursor.NextRow
    RowCounter = 2
    Do Until pRow Is Nothing
      RowCounter = RowCounter + 1
      ' frmPoints2Lines.Caption = "Processing " & RowCounter & " of " & RowCount & " total points."
    
      xVal2 = pRow.Value(Xindex)
      yVal2 = pRow.Value(Yindex)
      rowID2 = pRow.Value(IDindex)
      
      '--- if next row has same id then add a line segment to seg collection ---
      If rowID2 = rowID Then
        Set pLine = CreateLn(CreatePt(xVal, yVal), CreatePt(xVal2, yVal2))
        pSegColl.AddSegment pLine
        '--- otherwise, if seg collection has any segs then make a polyline ---
      ElseIf pSegColl.SegmentCount > 0 Then
        Set pGeomColl = New Polyline
        pGeomColl.AddGeometry pSegColl
        Set pFeature = pFeatureClass.CreateFeature
        Set pPolyline = pGeomColl
        Set pFeature.Shape = pPolyline
        pFeature.Value(ID_out_index) = rowID
        pFeature.Store
        pSegColl.RemoveSegments 0, pSegColl.SegmentCount, False
      End If
      
      '--- backcalculate to-pt to from-pt
      xVal = xVal2
      yVal = yVal2
      zVal = zVal2
      rowID = rowID2
      Set pRow = pCursor.NextRow
    Loop
    
    '--- deal with last line of file ---
    If rowID = rowID2 Then
      Set pGeomColl = New Polyline
      pGeomColl.AddGeometry pSegColl
      Set pFeature = pFeatureClass.CreateFeature
      Set pPolyline = pGeomColl
      Set pFeature.Shape = pPolyline
      pFeature.Value(ID_out_index) = rowID
      pFeature.Store
    End If
  
  '----- if NOT merging by segment IDs -----
  ElseIf strMergebyID = False Then
'''''    '--- get first row ---
'''''    Set pRow = pCursor.NextRow
'''''    xVal = pRow.Value(Xindex)
'''''    yVal = pRow.Value(Yindex)
'''''    rowID = pRow.Value(IDindex)
'''''
'''''    Set pRow = pCursor.NextRow
'''''    RowCounter = 2
'''''    Do Until pRow Is Nothing
'''''      RowCounter = RowCounter + 1
'''''      frmPoints2Lines.Caption = "Processing " & RowCounter & " of " & RowCount & " total points."
'''''
'''''      xVal2 = pRow.Value(Xindex)
'''''      yVal2 = pRow.Value(Yindex)
'''''      rowID2 = pRow.Value(IDindex)
'''''
'''''      '--- if next row has same id then add a line segment to seg collection ---
'''''      If rowID2 = rowID Then
'''''        Set pLine = CreateLn(CreatePt(xVal, yVal), CreatePt(xVal2, yVal2))
'''''        Set pSegColl = New path
'''''        pSegColl.AddSegment pLine
'''''        Set pGeomColl = New Polyline
'''''        pGeomColl.AddGeometry pSegColl
'''''        Set pFeature = pFeatureClass.CreateFeature
'''''        Set pPolyline = pGeomColl
'''''        Set pFeature.Shape = pPolyline
'''''        pFeature.Value(ID_out_index) = rowID
'''''        pFeature.Store
'''''      End If
'''''      xVal = xVal2
'''''      yVal = yVal2
'''''      rowID = rowID2
'''''      Set pRow = pCursor.NextRow
'''''    Loop
 
  End If
End Function

Private Function ConvertKMLpath2TXT(inputLocation As String, outputLocation As String)
    
    Dim strData As String, outputLocation2 As String
    
    outputLocation2 = outputLocation & Int((999999 - 100000 + 1) * Rnd + 100000) & ".tmp"
    

    Open inputLocation For Input As #1
    Open outputLocation2 For Output As #2
    Print #2, "long,lat,height"
    
    Dim LineNumber As Double
    LineNumber = 1

    ' coord1 is used to identify when the coordinate section has been found
    ' coord2 is used to identify when to start sending the coordinates to the new text file

    Dim coord1 As Long, coord2 As Long, coord3 As String
    coord1 = 0
    coord2 = 0

    Do While Not EOF(1)
    
    Line Input #1, strData ', data 'or lineinput
    strData = Replace(strData, " ", "")

        If strData = "<coordinates>" Then
        coord1 = 1
        GoTo endofloop
    End If

    If strData = "</coordinates>" Then GoTo exitloop

    If coord1 = 1 Then
        strData = Replace(strData, ",0", ",1A")
        strData = Replace(strData, "A", vbCrLf)
        Print #2, strData
    End If

endofloop:
        LineNumber = LineNumber + 1

    Loop
exitloop:

    Close 1
    Close 2

    Open outputLocation2 For Input As #2
    ConvertKMLpath2TXT = Int((999999 - 100000 + 1) * Rnd + 100000)
    
    outputLocation = outputLocation & ConvertKMLpath2TXT & ".txt"
   ' ConvertKMLpath2TXT = outputLocation
    
    Open outputLocation For Output As #3
    
    Do While Not EOF(2)
        Line Input #2, strData

        If strData = "" Then
            GoTo endoffunction
        Else
            Print #3, strData
        End If
    Loop

endoffunction:
    Close 2
    Close 3
    
    ' Need to remove the first temp file *.tmp
    KillProperly outputLocation2

End Function

Private Sub cbCancel_Click()
    Me.Hide
    Unload Me
End Sub

Private Sub cmdChooseInputFile_Click()
    MsgBox "In Development", vbInformation
End Sub

Private Function ConvertTXT2DBF(inputLocation As String, outPutPath As String)

    ' Create the Geoprocessor object
    Dim pGP As Object
    Set pGP = CreateObject("esriGeoprocessing.GPDispatch.1")
    
    pGP.Toolbox = "C:/Program Files/ArcGIS/ArcToolbox/Toolboxes/Conversion Tools.tbx"
    
    ' Load required toolboxes...
    pGP.AddToolbox "C:/Program Files/ArcGIS/ArcToolbox/Toolboxes/Conversion Tools.tbx"
    
    ' Process: Table to dBASE (multiple)...
    pGP.TableToDBASE_conversion inputLocation, outPutPath



End Function




Private Function CreateShapefile(ByVal ID_in_type As String, outputName As String)

' Set pFWS = pWorkspaceFactory.OpenFromFile(tbOutputPath, 0) ' "c:\path"
' If pFSO.FileExists(tbOutputPath & "\" & tbOutputFile) Then ' c:\path\name.shp
' Set pFeatClass = pFWS.OpenFeatureClass(tbOutputFile) ' name.shp
'   .name = cbIDs.Value ' "height"
' Set pFeatClass = pFWS.CreateFeatureClass(tbOutputFile, pFields, Nothing, Nothing, esriFTSimple, "Shape", "") ' tbOutputFile = "name.shp"



'----- delete if shapefile already exists -----
Dim pFWS As IFeatureWorkspace
Dim pWorkspaceFactory As IWorkspaceFactory
Set pWorkspaceFactory = New ShapefileWorkspaceFactory
Set pFWS = pWorkspaceFactory.OpenFromFile(tbInputPath.Value, 0)
Dim pFeatClass As IFeatureClass
Dim pDataset As IDataset

'----- if shapefile exists then delete -----
Dim pFSO As Object
Dim asdfsad As String
asdfsad = outputName & ".shp"

Set pFSO = CreateObject("Scripting.FileSystemObject")
If pFSO.FileExists(tbInputPath.Value & "\" & outputName & ".shp") Then
  Set pFeatClass = pFWS.OpenFeatureClass(outputName & ".shp")
   If (Not pFeatClass Is Nothing) Then
    Set pDataset = pFeatClass
    pDataset.Delete
  End If
End If
    
'----- Set up the shapefile geometry field -----
Dim pFields As IFields
Dim pFieldsEdit As IFieldsEdit
Set pFields = New Fields
Set pFieldsEdit = pFields
  
Dim pField As IField
Dim pFieldEdit As IFieldEdit
Set pField = New Field
Set pFieldEdit = pField
pFieldEdit.name = "Shape"
pFieldEdit.Type = esriFieldTypeGeometry
  
Dim pGeomDef As IGeometryDef
Dim pGeomDefEdit As IGeometryDefEdit
Set pGeomDef = New GeometryDef
Set pGeomDefEdit = pGeomDef
  With pGeomDefEdit
      .GeometryType = esriGeometryPolyline
      Set .SpatialReference = New UnknownCoordinateSystem
  End With
Set pFieldEdit.GeometryDef = pGeomDef
pFieldsEdit.AddField pField
        
'----- Add an ID field for relate back to point source field -----
Set pField = New Field
Set pFieldEdit = pField

With pFieldEdit
   .name = "height"
   .Type = ID_in_type
End With

pFieldsEdit.AddField pField
Dim temps22 As String
temp22 = outputName & ".shp"

'----- Create the shapefile -----
Set pFeatClass = pFWS.CreateFeatureClass(temp22, pFields, Nothing, Nothing, esriFTSimple, "Shape", "")

End Function
